/**************************************************************************
File Name: extendingNumTemp.cpp
Extending Signed and Unsigned Numbers
Method: Embedding an in-line assembly language modile into a C/C++ program


A. Extending a 16-bit unsigned number  to a 32-bit unsinged number
B. Extending a 16-bit signed number to a 32-bit signed number

printf() is used to display information on the console
cout is used to display the output on the console
cin is used to input the information form the keyboard
cout<hex is used to display the hexadecimal value 
cout<<dec is used to display decimal value
system("pause") is used to hold the console

**************************************************************************/

#include <stdio.h>
#include <iostream>
using namespace std;
int main() {
		
	unsigned char us8 = 0xfd;
	signed char s8 = 0xfd;
	unsigned short int us16;
	signed short int s16;
	unsigned int us32;
	signed int s32;

	signed short int sign16 = 0xfffd;
	unsigned short int usign16 = 0xfffd;


	/****************************************************************************************************/
	//An 8-bit unsigned number extending to a 16-bit unsigned number
	printf("************************************************************\n");
	printf("A 8-bit unsigned number extending to a 16-bit unsigned number\n");
	printf("unsigned hexadecimal value is 0x%x\n", us8);


	_asm {
		MOV AH, us8;		//Unsigned number moved to AH
		MOVZX AX, AH;		//Zero Extension
		MOV us16, AX;		//Move to 16 - bit unsigned number
	}

	cout << "After Zero Extension,\n"
		<< "the identical hex value with 16 bit unsigned number is " << hex << us16 << endl;
	cout << " and its associated decimal is " << dec << us16 << endl;

	/****************************************************************************************************/

	//An 8-bit signed number extending to a 16-bit signed number
	printf("************************************************************\n");
	printf("A 8-bit signed number extending to a 16-bit signed number\n");
	printf("signed hexadecimal value is 0x%x\n", s8);


	_asm {
		MOV BH, s8;			//Signed number moved to AH
		MOVSX BX, BH;		//Sign Extension
		MOV s16, BX;		Move to 16 - bit unsigned number
	}

	cout << "After Sign Extension,\n"
		<< "the identical hex value with 16 bit signed number is " << hex << s16 << endl;
	cout << " and its associated decimal is " << dec << s16 << endl;

	/****************************************************************************************************/

	//An 8-bit unsigned number extending to a 32-bit unsigned number
	printf("************************************************************\n");
	printf("A 8-bit unsigned number extending to a 32-bit unsigned number\n");
	printf("unsigned hexadecimal value is 0x%x\n", us8);


	_asm {
		MOV AH, us8;		//Unsigned number moved to AH
		MOVZX EAX, AH;		//Zero Extension
		MOV us32, EAX;		//Move to 32 - bit unsigned number
	}

	cout << "After Zero Extension,\n"
		<< "the identical hex value with 32 bit unsigned number is " << hex << us32 << endl;
	cout << " and its associated decimal is " << dec << us32 << endl;

	/****************************************************************************************************/

	//An 8-bit signed number extending to a 32-bit signed number
	printf("************************************************************\n");
	printf("A 8-bit signed number extending to a 32-bit signed number\n");
	printf("signed hexadecimal value is 0x%x\n", s8);


	_asm {
		MOV AH, s8;			//Signed number moved to AH
		MOVSX EAX, AH;		//Sign Extension
		MOV s32, EAX;		//Move to 32 - bit signed number
	}

	cout << "After Sign Extension,\n"
		<< "the identical hex value with 32 bit signed number is " << hex << s32 << endl;
	cout << " and its associated decimal is " << dec << s32 << endl;



	/****************************************************************************************************/

	//An 16-bit signed number extending to a 32-bit signed number
	printf("************************************************************\n");
	printf("A 16-bit signed number extending to a 32-bit signed number\n");
	printf("signed hexadecimal value is 0x%x\n", sign16);


	_asm {
		MOV AX, sign16;		//Signed number moved to AX
		MOVSX EAX, AX;		//Sign Extension
		MOV s32, EAX;		//Move to 32 - bit signed number
	}

	cout << "After Sign Extension,\n"
		<< "the identical hex value with 32 bit signed number is " << hex << s32 << endl;
	cout << " and its associated decimal is " << dec << s32 << endl;


	/****************************************************************************************************/

	//An 16-bit unsigned number extending to a 32-bit unsigned number
	printf("************************************************************\n");
	printf("A 16-bit unsigned number extending to a 32-bit unsigned number\n");
	printf("unsigned hexadecimal value is 0x%x\n", usign16);


	_asm {
		MOV AX, usign16;	//Unsigned number moved to AX
		MOVSX EAX, AX;		//Sign Extension
		MOV us32, EAX;		//Move to 32 - bit unsigned number
	}

	cout << "After Sign Extension,\n"
		<< "the identical hex value with 32 bit signed number is " << hex << us32 << endl;
	cout << " and its associated decimal is " << dec << us32 << endl;

	system("pause");
	return 0;


}